## tasmanian 8.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

cmake_policy(VERSION 3.19)
project(Tasmanian VERSION 8.1.0 LANGUAGES CXX)
set(Tasmanian_version_comment "") # e.g., " (release candidate)", " (development)", ""
set(Tasmanian_license "BSD 3-Clause with UT-Battelle disclaimer") # used in some headers and python modules (only human readable)

########################################################################
#  User specified options:
#    -D Tasmanian_ENABLE_RECOMMENDED:BOOL=OFF (includes some flags)
#    -D Tasmanian_ENABLE_OPENMP:BOOL=OFF      (recommended)
#    -D Tasmanian_ENABLE_BLAS:BOOL=OFF        (recommended)
#    -D Tasmanian_ENABLE_PYTHON:BOOL=OFF      (recommended)
#    -D Tasmanian_ENABLE_CUDA:BOOL=OFF        (stable)
#    -D Tasmanian_ENABLE_HIP:BOOL=OFF         (stable)
#    -D Tasmanian_ENABLE_DPCPP:BOOL=OFF       (stable)
#    -D Tasmanian_ENABLE_MAGMA:BOOL=OFF       (stable)
#    -D Tasmanian_MATLAB_WORK_FOLDER:PATH=""  (stable)
#    -D Tasmanian_ENABLE_FORTRAN:BOOL=OFF     (stable)
#    -D Tasmanian_ENABLE_MPI:BOOL=OFF         (stable)
#    -D Tasmanian_ENABLE_SWIG:BOOL=OFF        (stable)
#
# Additional options: (if default test behavior is not desired)
#    -D Tasmanian_TESTS_OMP_NUM_THREADS:INT="sets OpenMP number of threads"
#    -D Tasmanian_TESTS_GPU_ID:INT="specifies which GPU to use for testing"
#
# Extra options: (allow for workarounds of bugs and exotic systems)
#    -D Tasmanian_EXTRA_LIBRARIES:STRING="appends more link libraries"
#    -D Tasmanian_EXTRA_INCLUDE_DIRS:LIST="appends more include paths"
#    -D Tasmanian_EXTRA_LINK_DIRS:PATH="appends more link paths"
#
# Selecting specific packages for find_package()
#     -D Python_ROOT_DIR:PATH
#     -D CMAKE_CUDA_COMPILER:PATH
#     -D Tasmanian_MAGMA_ROOT:PATH (or just MAGMA_ROOT)
#     -D MPI_CXX_COMPILER
#     -D MPI_Fortran_COMPILER (must be compatible with the MPI_CXX_COMPILER)
#     -D MPIEXEC_EXECUTABLE   (must be compatible with the MPI_CXX_COMPILER)
#     -D SWIG_EXECUTABLE      (path to swigfortran)
#     (note: swig may require extra includes, use Tasmanian_EXTRA_INCLUDE_DIRS)
#
# Directly specifying libraries and bypassing find_package()
#     -D BLAS_LIBRARIES
#     -D LAPACK_LIBRARIES
#
# Note: directly specifying libraries still requires the corresponding
#       Tasmanian_ENABLE_ option
#
########################################################################

########################################################################
# The build process follows these steps:
# 1. Define all options and assign default values
# 2. Perform sanity check
#    - resolve conflicts, e.g., Python requires shared libs
#    - call find_package() for options that need packages
#    - fail or fallback if find_package() fails for some option
#    - add Tasmanian_dependencies target with all TPLs
# 3. Enable testing and set the master config file
# 4. Add all subdirectories in the correct order
#    - SparseGirds, DREAM, Addons
#    - Interfaces: Python, Fortran, MATLAB
#    - master target and examples
# 5. Install top level files
#    - add the "make test_install" target
#    - cmake export file
#    - master config file
#    - CMakeLists.txt for the examples (include OpenMP hack if needed)
#    - shell (bash) source file that defines paths
# 6. Print final messages
########################################################################

option(BUILD_SHARED_LIBS            "Specify shared or static libraries for Tasmanian"  ON)
option(Tasmanian_ENABLE_RECOMMENDED "Enable (if found) OpenMP, BLAS, and Python, also sets optimization flags" OFF)
option(Tasmanian_ENABLE_OPENMP      "Enable OpenMP support for Tasmanian (recommended)"    OFF)
option(Tasmanian_ENABLE_BLAS        "Enable CPU Blas support for Tasmanian (recommended)"  OFF)
option(Tasmanian_ENABLE_PYTHON      "Enable Python interface for Tasmanian (recommended)"  OFF)
option(Tasmanian_ENABLE_CUDA        "Enable Nvidia CUDA kernels and libraries within Tasmanian (stable)"    OFF)
option(Tasmanian_ENABLE_HIP         "Enable AMD HIP kernels and ROCm libraries within Tasmanian (stable)"   OFF)
option(Tasmanian_ENABLE_DPCPP       "Enable Intel DPC++ kernels and libraries within Tasmanian (stable)"    OFF)
option(Tasmanian_ENABLE_MAGMA       "Enable acceleration using UTK Magma library within Tasmanian (stable)" OFF)
option(Tasmanian_ENABLE_FORTRAN     "Enable Fortran interface for Tasmanian (stable)" OFF)
option(Tasmanian_ENABLE_MPI         "Enable MPI support for Tasmanian (stable)"       OFF)
option(Tasmanian_ENABLE_SWIG        "Regenerate Fortran 2003 bindings with SWIG (developers only)"       OFF)
option(Tasmanian_ENABLE_DOXYGEN     "Enable Doxygen documentation for Tasmanian (complete)" OFF)

option(Tasmanian_ENABLE_FORTRAN90   "(deprecated, untested) Enable the old Fortran 90 interface of Tasmanian" OFF)

# treat those similar to options, but give values other than ON/OFF
set(Tasmanian_MATLAB_WORK_FOLDER     ""  CACHE PATH   "Enable MATLAB interface and use the path for the MATLAB work folder (stable)")

set(Tasmanian_TESTS_GPU_ID          "-1" CACHE STRING "(integer) specify GPU ID for testing, -1 means running tests on all visible devices (optional)")
set(Tasmanian_TESTS_OMP_NUM_THREADS "-1" CACHE STRING "(integer) specify OMP_NUM_THREADS for the tests, if less than 0, this option will be ignored (optional)")

# allow an external project to specify the export variable name
if (${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    set(Tasmanian_export_name "Tasmanian-export")
    enable_testing() # Tasmanian is the main project, enable testing
else()
    set(Tasmanian_export_name "Tasmanian-export" CACHE STRING "Specify the export variable name when merging Tasmanian into an external project")
endif()

if (Tasmanian_ENABLE_CUDA AND NOT DEFINED CMAKE_CUDA_ARCHITECTURES)
    set(CMAKE_CUDA_ARCHITECTURES "OFF" CACHE STRING "CUDA architectures to compile, e.g., -DCMAKE_CUDA_ARCHITECTURES=70;72")
endif()

if (Tasmanian_ENABLE_ROCM) # alias option
    set(Tasmanian_ENABLE_HIP ON)
endif()

########################################################################
# Sanity check, xSDK compatibility, and find_package() calls are all
# done in one place for consistency
# after this call, every enabled option comes with proper found set of
# find_package() provided libraries, includes, etc.
# Also adds Tasmanian_dependencies that links to all dependencies
########################################################################
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/helper_macros.cmake")
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/sanity_check_and_xsdk.cmake")
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/add_dependencies_target.cmake")


########################################################################
# Core project configuration, passes all options to CXX
########################################################################
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Config/TasmanianConfig.in.hpp"
               "${CMAKE_CURRENT_BINARY_DIR}/configured/TasmanianConfig.hpp")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/configured/TasmanianConfig.hpp"
        DESTINATION include
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)
# configure the headers for the logs
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Tasgrid/tasgridLogs.in.hpp" "${CMAKE_CURRENT_BINARY_DIR}/configured/tasgridLogs.hpp")


########################################################################
# Setup targets
# CXX subdirs have to come first, SparseGrids must precede DREAM
# the Addons must come last
# each sub-directory creates a set of targets and links those to
# existing targets (hence the order is important)
# After CXX, the interfaces Fortran, Python, MATLAB can come in any order
# Finally, add the master target to link to all of the above
########################################################################
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/SparseGrids" "${CMAKE_CURRENT_BINARY_DIR}/SparseGrids")
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/DREAM"       "${CMAKE_CURRENT_BINARY_DIR}/DREAM")
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Addons"      "${CMAKE_CURRENT_BINARY_DIR}/Addons")
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Tasgrid/"    "${CMAKE_CURRENT_BINARY_DIR}/Tasgrid")

if (Tasmanian_ENABLE_FORTRAN)
    if (Tasmanian_ENABLE_FORTRAN90)
        add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/InterfaceFortran"  "${CMAKE_CURRENT_BINARY_DIR}/Fortran")
    endif()
    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/InterfaceSwig"
                     "${CMAKE_CURRENT_BINARY_DIR}/Fortran03")
endif()

if (Tasmanian_ENABLE_PYTHON)
    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/InterfacePython"  "${CMAKE_CURRENT_BINARY_DIR}/Python")
endif()

if (NOT "${Tasmanian_MATLAB_WORK_FOLDER}" STREQUAL "")
    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/InterfaceMATLAB"  "${CMAKE_CURRENT_BINARY_DIR}/MATLAB")
endif()

if (Tasmanian_ENABLE_DOXYGEN)
    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Doxygen"  "${CMAKE_CURRENT_BINARY_DIR}/Doxygen")
endif()

include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/master_targets.cmake")
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/all_examples.cmake")


########################################################################
# Tasmanian is merged into an external master project then skip the exports
# The master should be responsible for post-install testing and exporting
########################################################################
if (${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/exports.cmake")
endif()


########################################################################
# Setup Message
########################################################################
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/setup_message.cmake")

=== Makefile ===
#include Config/AltBuildSystems/Makefile.in

# disable openmp on non-Linux platforms
UNAME = $(shell uname)
ifeq ($(UNAME), Linux)
OPENMPFLAGS = -fopenmp
else
OPENMPFLAGS = -Wno-unknown-pragmas
endif

# Default C++ compiler
CC = g++
CXXFLAGS = -O3 -std=c++11 $(OPENMPFLAGS) -fPIC

IADD = -I./include -I./SparseGrids/ -I./InterfaceTPL/ -I./DREAM/ -I./DREAM/Optimization/ -I./Addons/ -I./
LADD = -L./

# set the compile command
COMPILE = $(CC) $(CXXFLAGS) $(IADD) $(LADD)
ECOMPILE = $(CC) $(CXXFLAGS) -I./include

# check if Python exists, disable python with TSG_SKIP_PYTHON=1
ifneq ($(shell echo "import numpy; print(numpy.__version__ )" | python3 2>/dev/null),)
HAS_PYTHON := "Yes"
endif

# object files for each target
SparseGridsObj = \
          ./SparseGrids/tsgIndexSets.o ./SparseGrids/tsgCoreOneDimensional.o ./SparseGrids/tsgIndexManipulator.o ./SparseGrids/tsgGridGlobal.o \
          ./SparseGrids/tsgSequenceOptimizer.o ./SparseGrids/tsgLinearSolvers.o ./SparseGrids/tsgGridSequence.o ./SparseGrids/tsgHardCodedTabulatedRules.o \
          ./SparseGrids/tsgHierarchyManipulator.o ./SparseGrids/tsgGridLocalPolynomial.o ./SparseGrids/tsgRuleWavelet.o ./SparseGrids/tsgGridWavelet.o \
          ./SparseGrids/tsgGridFourier.o ./SparseGrids/tsgDConstructGridGlobal.o ./SparseGrids/tsgAcceleratedDataStructures.o \
          ./SparseGrids/TasmanianSparseGridWrapC.o ./SparseGrids/TasmanianSparseGrid.o ./InterfaceTPL/tsgGpuNull.o

DREAMObj = \
          ./DREAM/tsgDreamState.o ./DREAM/tsgDreamLikelyGaussian.o ./DREAM/tsgDreamSampleWrapC.o \
          ./DREAM/Optimization/tsgParticleSwarm.o ./DREAM/Optimization/tsgGradientDescent.o \
          ./DREAM/Optimization/TasmanianOptimizationWrapC.o

AddonsObj = \
          ./Addons/tsgCLoadNeededValues.o ./Addons/tsgCConstructSurrogate.o ./Addons/tsgCLoadUnstructuredPoints.o ./Addons/tsgCExoticQuadrature.o

TasgridObj = \
          ./Tasgrid/tasgrid_main.o ./SparseGrids/gridtestTestFunctions.o ./SparseGrids/gridtestExternalTests.o ./Tasgrid/tasgridWrapper.o

# test objects
GidtestObj = \
          ./SparseGrids/gridtest_main.o ./SparseGrids/gridtestTestFunctions.o ./SparseGrids/gridtestExternalTests.o \
          ./SparseGrids/gridtestUnitTests.o ./SparseGrids/gridtestTestInterfaceC.o

DREAMTestObj = \
          ./DREAM/dreamtest_main.o ./DREAM/tasdreamExternalTests.o ./DREAM/Optimization/tasdreamOptimizationTests.o

AddonTestObj = \
          ./Addons/testAddons.o

# example objects
SGExampleObj = \
          ./SparseGrids/Examples/example_sparse_grids.o     ./SparseGrids/Examples/example_sparse_grids_01.o \
          ./SparseGrids/Examples/example_sparse_grids_02.o  ./SparseGrids/Examples/example_sparse_grids_03.o \
          ./SparseGrids/Examples/example_sparse_grids_04.o  ./SparseGrids/Examples/example_sparse_grids_05.o \
          ./SparseGrids/Examples/example_sparse_grids_06.o  ./SparseGrids/Examples/example_sparse_grids_07.o \
          ./SparseGrids/Examples/example_sparse_grids_08.o  ./SparseGrids/Examples/example_sparse_grids_09.o \
          ./SparseGrids/Examples/example_sparse_grids_10.o  ./SparseGrids/Examples/example_sparse_grids_11.o

DREAMExampleObj = \
          ./DREAM/Examples/example_dream.o     ./DREAM/Examples/example_dream_01.o \
          ./DREAM/Examples/example_dream_02.o  ./DREAM/Examples/example_dream_03.o \
          ./DREAM/Examples/example_dream_04.o  ./DREAM/Examples/example_dream_05.o

OptExampleObj = \
          ./DREAM/Examples/example_optimization.o     ./DREAM/Examples/example_optimization_01.o \
          ./DREAM/Examples/example_optimization_02.o

# all target
.PHONY: all
all: tasgrid
	@echo ""
	@echo "TASMANIAN Simple GNU Make engine:"
	@echo "Complete build for C/C++, CLI and Python interfaces"
	@echo "MATLAB interface uses 'make matlab'"


# help
.PHONY: help
help:
	@echo "TASMANIAN Simple GNU Make tool"
	@echo " make"
	@echo " make test"
	@echo " make examples"
	@echo " make test_examples"
	@echo " make matlab"


# linear dependence pattern: sparse-grid -> dream -> addons -> python -> tasgrid
tasgrid: Tasmanian.py $(TasgridObj)
	@echo " -- building the tasgrid executable"
	$(COMPILE) $(TasgridObj) $(SparseGridsObj) -o tasgrid

Tasmanian.py: libtasmaniancaddons.so
	@echo " -- building the Python module"
	cp ./InterfacePython/TasmanianConfig.in.py TasmanianConfig.py
	sed -i -e 's|@Tasmanian_VERSION_MAJOR@|'8'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_VERSION_MINOR@|'1'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_license@|'BSD\ 3-Clause\ with\ UT-Battelle\ disclaimer'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_git_hash@|'Tasmanian\ git\ hash\ is\ not\ available\ here'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_libsparsegrid_path@|'`pwd`/libtasmaniansparsegrid.so'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_libdream_path@|'`pwd`/libtasmaniandream.so'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_libcaddons_path@|'`pwd`/libtasmaniancaddons.so'|g' ./TasmanianConfig.py
	cp ./InterfacePython/Tasmanian* .

libtasmaniancaddons.so: libtasmaniandream.so $(AddonsObj)
	@echo " -- building the Addons module"
	cp ./Addons/*.hpp ./include/
	$(COMPILE) -shared $(AddonsObj) -o libtasmaniancaddons.so ./libtasmaniandream.so ./libtasmaniansparsegrid.so

libtasmaniandream.so: libtasmaniansparsegrid.so $(DREAMObj)
	@echo " -- building the DREAM module"
	cp ./DREAM/*.hpp ./include/
	cp ./DREAM/Optimization/*.hpp ./include/
	ar rcs libtasmaniandream.a $(DREAMObj)
	$(COMPILE) -shared $(DREAMObj) -o libtasmaniandream.so ./libtasmaniansparsegrid.so

libtasmaniansparsegrid.so: $(SparseGridsObj)
	@echo " -- building the Sparse Grid module"
	cp ./SparseGrids/*.h ./include/
	cp ./SparseGrids/*.hpp ./include/
	ar rcs libtasmaniansparsegrid.a $(SparseGridsObj)
	$(COMPILE) -shared $(SparseGridsObj) -o libtasmaniansparsegrid.so

%.o: %.cpp ./include
	$(COMPILE) -c $< -o $@

include:
	mkdir -p ./include
	cp ./Tasgrid/tasgridLogs.in.hpp ./include/tasgridLogs.hpp
	sed -i '/std/,/endl/d' ./include/tasgridLogs.hpp
	sed -i -e 's|@CMAKE_CURRENT_BINARY_DIR@|'.'|g' ./include/tasgridLogs.hpp
	sed -i -e 's|@Tasmanian_final_install_path@/share/Tasmanian|'.'|g' ./include/tasgridLogs.hpp
	sed -i -e 's|}|'std::cout\<\<\"Unavailable\ without\ CMake\"\<\<std::endl\;\}'|g' ./include/tasgridLogs.hpp
	cp ./Config/AltBuildSystems/TasmanianConfig.hpp ./include/TasmanianConfig.hpp
	cp ./Config/Tasmanian.hpp ./include/


# test target, also compiles the tests
.PHONY: test
test: gridtest dreamtest addontester
	./gridtest
	./dreamtest
	./addontester
ifdef HAS_PYTHON
	cp ./SparseGrids/GaussPattersonRule.table .
	cp ./Config/AltBuildSystems/testConfigureData.py InterfacePython/
	PYTHONPATH=$(PYTHONPATH):./InterfacePython python3 ./InterfacePython/testTSG.py && { echo "SUCCESS: Test completed successfully"; }
else
	@echo "WARNING: Cannot find python3 with numpy in the system path, skipping the Python tests."
endif

addontester: $(AddonTestObj)
	$(COMPILE) $(AddonTestObj) -o addontester libtasmaniansparsegrid.a libtasmaniandream.a

dreamtest: $(DREAMTestObj)
	$(COMPILE) $(DREAMTestObj) -o dreamtest libtasmaniansparsegrid.a libtasmaniandream.a

gridtest: $(GidtestObj)
	$(COMPILE) $(GidtestObj) -o gridtest libtasmaniansparsegrid.a libtasmaniandream.a


# examples
.PHONY: examples
examples: example_sparse_grids example_dream example_optimization
	cp ./InterfacePython/example_sparse_grids.in.py ./InterfacePython/example_sparse_grids.py
	sed -i -e 's|@Tasmanian_string_python_hashbang@|'\/usr\/bin\/env\ python3'|g' ./InterfacePython/example_sparse_grids.py
	sed -i -e 's|@Tasmanian_python_example_import@|'sys.path.append\(\"`pwd`\"\)'|g' ./InterfacePython/example_sparse_grids.py
	cp ./InterfacePython/example_dream.in.py ./InterfacePython/example_dream.py
	sed -i -e 's|@Tasmanian_string_python_hashbang@|'\/usr\/bin\/env\ python3'|g' ./InterfacePython/example_dream.py
	sed -i -e 's|@Tasmanian_python_example_import@|'sys.path.append\(\"`pwd`\"\)'|g' ./InterfacePython/example_dream.py
	cp ./InterfacePython/example_optimization.in.py ./InterfacePython/example_optimization.py
	sed -i -e 's|@Tasmanian_string_python_hashbang@|'\/usr\/bin\/env\ python3'|g' ./InterfacePython/example_optimization.py
	sed -i -e 's|@Tasmanian_python_example_import@|'sys.path.append\(\"`pwd`\"\)'|g' ./InterfacePython/example_optimization.py
	@echo "Compiled the examples, run with the commands"
	@echo "./example_sparse_grids"
	@echo "./example_dream"
	@echo "./example_optimization"
	@echo "python3 ./InterfacePython/example_sparse_grids.py"
	@echo "python3 ./InterfacePython/example_dream.py"
	@echo "python3 ./InterfacePython/example_optimization.py"

example_sparse_grids: $(SGExampleObj)
	$(ECOMPILE) $(SGExampleObj) -o example_sparse_grids ./libtasmaniansparsegrid.a

example_dream: $(DREAMExampleObj)
	$(ECOMPILE) $(DREAMExampleObj) -o example_dream ./libtasmaniansparsegrid.a ./libtasmaniandream.a

example_optimization: $(OptExampleObj)
	$(ECOMPILE) $(OptExampleObj) -o example_optimization ./libtasmaniansparsegrid.a ./libtasmaniandream.a

SparseGrids/Examples/example_sparse_grids%.o: SparseGrids/Examples/example_sparse_grids%.cpp
	$(ECOMPILE) -c $< -o $@

DREAM/Examples/example_dream%.o: DREAM/Examples/example_dream%.cpp
	$(ECOMPILE) -c $< -o $@

DREAM/Examples/example_optimization%.o: DREAM/Examples/example_optimization%.cpp
	$(ECOMPILE) -c $< -o $@

# examples testing
.PHONY: test_examples
test_examples: examples
	./example_sparse_grids
	./example_dream
	./example_optimization
ifdef HAS_PYTHON
	python3 ./InterfacePython/example_sparse_grids.py
	python3 ./InterfacePython/example_dream.py
	python3 ./InterfacePython/example_optimization.py
endif


# Matlab
.PHONY: matlab
matlab:
	cp Config/AltBuildSystems/tsgGetPaths.m InterfaceMATLAB/tsgGetPaths.m
	mkdir -p tsgMatlabWorkFolder
	sed -i -e 's|ENTER\ THE\ PATH\ TO\ MATLAB\ WORK\ FOLDER|'`pwd`/tsgMatlabWorkFolder/'|g' InterfaceMATLAB/tsgGetPaths.m
	sed -i -e 's|ENTER\ THE\ PATH\ TO\ tasgrid\ EXECUTABLE|'`pwd`/tasgrid'|g' InterfaceMATLAB/tsgGetPaths.m
	@echo ""
	@echo "Setting MATLAB work forlder to "`pwd`"/tsgMatlabWorkFolder/"
	@echo "use MATLAB command: addpath('"`pwd`"/InterfaceMATLAB/');"
	@echo ""


# Clean
.PHONY: clean
clean:
	rm -fr libtasmaniansparsegrid.so
	rm -fr libtasmaniansparsegrid.a
	rm -fr libtasmaniandream.so
	rm -fr libtasmaniandream.a
	rm -fr libtasmaniancaddons.so
	rm -fr tasgrid
	rm -fr gridtest
	rm -fr dreamtest
	rm -fr addontester
	rm -fr Tasmanian*.py
	rm -fr *.pyc
	rm -fr GaussPattersonRule.table
	rm -fr __pycache__
	rm -fr ./InterfacePython/__pycache__
	rm -fr ./InterfacePython/*.pyc
	rm -fr ./InterfacePython/example_sparse_grids.py
	rm -fr ./InterfacePython/example_dream.py
	rm -fr ./InterfacePython/example_optimization.py
	rm -fr ./InterfacePython/testConfigureData.py
	rm -fr InterfaceMATLAB/tsgGetPaths.m
	rm -fr example_sparse_grids
	rm -fr example_dream
	rm -fr example_optimization
	rm -fr include
	rm -fr ./SparseGrids/*.o
	rm -fr ./DREAM/*.o
	rm -fr ./DREAM/Optimization/*.o
	rm -fr ./Addons/*.o
	rm -fr ./Tasgrid/*.o
	rm -fr ./InterfaceTPL/*.o
	rm -fr ./SparseGrids/Examples/*.o
	rm -fr ./DREAM/Examples/*.o
	rm -fr ./tsgMatlabWorkFolder
	rm -fr ./testSave
	rm -fr ./refTestFlename.grid

=== Addons/CMakeLists.txt ===
########################################################################
# Addon templates and related tests and interface options
########################################################################

add_library(Tasmanian_addons INTERFACE)

foreach(_tsg_file tsgAddonsCommon.hpp
                  tsgMPIScatterGrid.hpp
                  tsgMPIScatterDream.hpp
                  tsgMPISampleDream.hpp
                  tsgLoadNeededValues.hpp
                  tsgLoadUnstructuredPoints.hpp
                  tsgCandidateManager.hpp
                  tsgConstructSurrogate.hpp
                  tsgMPIConstructGrid.hpp
                  tsgExoticQuadrature.hpp
                  TasmanianAddons.hpp)
    target_sources(Tasmanian_addons INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${_tsg_file}>
                                              $<INSTALL_INTERFACE:${Tasmanian_final_install_path}/include/${_tsg_file}>)
endforeach()

target_include_directories(Tasmanian_addons INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
target_link_libraries(Tasmanian_addons INTERFACE Tasmanian_libdream)

if (Tasmanian_ENABLE_PYTHON) # the C addons are used by Python
    add_library(Tasmanian_caddons SHARED tsgCExoticQuadrature.cpp 
                                         tsgCLoadNeededValues.cpp 
                                         tsgCConstructSurrogate.cpp 
                                         tsgCLoadUnstructuredPoints.cpp)

    target_link_libraries(Tasmanian_caddons  Tasmanian_addons)

    set_target_properties(Tasmanian_caddons PROPERTIES OUTPUT_NAME "tasmaniancaddons"
                                                       INSTALL_RPATH "${Tasmanian_rpath}"
                                                       SOVERSION ${Tasmanian_VERSION_MAJOR}
                                                       VERSION   ${PROJECT_VERSION})

    install(TARGETS Tasmanian_caddons
            EXPORT  "${Tasmanian_export_name}"
            RUNTIME DESTINATION "bin"
            LIBRARY DESTINATION "lib"
            ARCHIVE DESTINATION "lib")
endif()

# The Tasmanian MPI capabilities are templated into the Addons
if (Tasmanian_ENABLE_MPI)
    target_link_libraries(Tasmanian_addons INTERFACE MPI::MPI_CXX)

    add_executable(Tasmanian_mpitester testMPI.cpp testMPI.hpp testMPIDream.hpp)
    add_test(MPISparseGridsIO ${MPIEXEC_EXECUTABLE} ${MPIEXEC_NUMPROC_FLAG} 3 ${MPIEXEC_PREFLAGS} ${CMAKE_CURRENT_BINARY_DIR}/mpitester ${MPIEXEC_POSTFLAGS})

    list(APPEND Tasmanian_addons_executables "mpitester")
    list(APPEND Tasmanian_addons_tests "MPISparseGridsIO")
endif()

# test for non-MPI capabilities
add_executable(Tasmanian_addontester testAddons.cpp testConstructSurrogate.hpp testLoadUnstructured.hpp)
add_test(AddonTests addontester -gpuid ${Tasmanian_TESTS_GPU_ID})

list(APPEND Tasmanian_addons_executables "addontester")
list(APPEND Tasmanian_addons_tests "AddonTests")

# set properties for all executable targets
foreach(_tsg_exec ${Tasmanian_addons_executables})
    set_target_properties(Tasmanian_${_tsg_exec} PROPERTIES OUTPUT_NAME "${_tsg_exec}" CXX_EXTENSIONS OFF)
    Tasmanian_rpath_target(TARGET Tasmanian_${_tsg_exec} USE_CURRENT COMPONENTS SparseGrids DREAM)
    target_link_libraries(Tasmanian_${_tsg_exec} Tasmanian_addons Tasmanian_libdream)
endforeach()
unset(_tsg_exec)

# cheap models have huge random variation in time-per-sample which can cause tests to fail
# make sure other tests are not holding resources and making things even worse
set_tests_properties(${Tasmanian_addons_tests} PROPERTIES RUN_SERIAL ON)
Tasmanian_set_test_properties(TESTS ${Tasmanian_addons_tests})

# Windows specific support (DLL export/import directives and names)
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    if (TARGET Tasmanian_caddons)
        set_target_properties(Tasmanian_caddons PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
    endif()
    if (BUILD_SHARED_LIBS)
        set(Tasmanian_MSVC_PATH_STRING "${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/Release;${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/Debug")
        set(Tasmanian_MSVC_PATH_STRING "${Tasmanian_MSVC_PATH_STRING};${CMAKE_CURRENT_BINARY_DIR}/../DREAM/Release;${CMAKE_CURRENT_BINARY_DIR}/../DREAM/Debug;$ENV{PATH}")
        string(REPLACE ";" "\\;" Tasmanian_MSVC_PATH_STRING "${Tasmanian_MSVC_PATH_STRING}")
        set_tests_properties(${Tasmanian_addons_tests} PROPERTIES ENVIRONMENT "PATH=${Tasmanian_MSVC_PATH_STRING}")
    endif()
endif()

# install directives
target_include_directories(Tasmanian_addons INTERFACE $<INSTALL_INTERFACE:include>)
get_target_property(_tsg_sources Tasmanian_addons INTERFACE_SOURCES)
install(FILES ${_tsg_sources} DESTINATION include)
install(TARGETS Tasmanian_addons EXPORT "${Tasmanian_export_name}" PUBLIC_HEADER DESTINATION include)

# cleanup
unset(_tsg_sources)
unset(Tasmanian_addons_executables)
unset(Tasmanian_addons_tests)

=== DREAM/CMakeLists.txt ===
########################################################################
# DREAM librareis and command line tool
########################################################################

add_library(Tasmanian_libdream  TasmanianDREAM.hpp
                                tsgDreamState.hpp
                                tsgDreamState.cpp
                                tsgDreamSample.hpp
                                tsgDreamSampleWrapC.cpp
                                tsgDreamLikelihoodCore.hpp
                                tsgDreamLikelyGaussian.hpp
                                tsgDreamLikelyGaussian.cpp
                                tsgDreamCoreRandom.hpp
                                tsgDreamCorePDF.hpp
                                tsgDreamEnumerates.hpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/TasmanianOptimization.hpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/TasmanianOptimizationWrapC.cpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgParticleSwarm.hpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgParticleSwarm.cpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgGradientDescent.hpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgGradientDescent.cpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgOptimizationUtils.hpp)

target_include_directories(Tasmanian_libdream PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>)
target_link_libraries(Tasmanian_libdream  Tasmanian_libsparsegrid)

set_target_properties(Tasmanian_libdream PROPERTIES OUTPUT_NAME "tasmaniandream"
                                                    SOVERSION ${Tasmanian_VERSION_MAJOR}
                                                    VERSION   ${PROJECT_VERSION})
Tasmanian_rpath_target(TARGET Tasmanian_libdream COMPONENTS SparseGrids)

if (Tasmanian_ENABLE_OPENMP)
    target_compile_options(Tasmanian_libdream PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${OpenMP_CXX_FLAGS}>)
endif()

install(TARGETS Tasmanian_libdream
        EXPORT  "${Tasmanian_export_name}"
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "lib"
        ARCHIVE DESTINATION "lib")


########################################################################
# add dreamtest and examples executables
########################################################################
add_executable(Tasmanian_dreamtest dreamtest_main.cpp
                                   tasdreamExternalTests.hpp
                                   tasdreamExternalTests.cpp
                                   ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tasdreamOptimizationTests.cpp)

set_target_properties(Tasmanian_dreamtest  PROPERTIES OUTPUT_NAME "dreamtest"
                                                      CXX_EXTENSIONS OFF)
Tasmanian_rpath_target(TARGET Tasmanian_dreamtest USE_CURRENT COMPONENTS SparseGrids)
target_link_libraries(Tasmanian_dreamtest  Tasmanian_libdream)


########################################################################
# Testing
########################################################################
add_test(DreamAnalytic dreamtest analytic)
add_test(DreamModel dreamtest posterior)
add_test(Optimization dreamtest optimization)
Tasmanian_set_test_properties(TESTS DreamAnalytic DreamModel)


########################################################################
# Windows specific support (DLL export/import directives and names)
########################################################################
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

    foreach(_tsg_target libdream dreamtest)
        target_compile_definitions(Tasmanian_${_tsg_target} PRIVATE -D_SCL_SECURE_NO_WARNINGS)
    endforeach()
    unset(_tsg_target)

    if (BUILD_SHARED_LIBS)
        set_target_properties(Tasmanian_libdream PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)

        set(Tasmanian_MSVC_PATH_STRING "${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/Release;${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/Debug;$ENV{PATH}")
        string(REPLACE ";" "\\;" Tasmanian_MSVC_PATH_STRING "${Tasmanian_MSVC_PATH_STRING}")
        set_tests_properties(DreamAnalytic DreamModel Optimization PROPERTIES ENVIRONMENT "PATH=${Tasmanian_MSVC_PATH_STRING}")
    endif()

endif()

########################################################################
# Install headers and config files
########################################################################
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
        DESTINATION include
        FILES_MATCHING PATTERN "*.hpp"
        PATTERN "*.windows.*" EXCLUDE
        PATTERN "*.in.*" EXCLUDE
        PATTERN "Examples" EXCLUDE)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/Optimization/"
        DESTINATION include
        FILES_MATCHING PATTERN "*.hpp"
        PATTERN "*.windows.*" EXCLUDE
        PATTERN "*.in.*" EXCLUDE
        PATTERN "Examples" EXCLUDE)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/Examples/"
        DESTINATION "share/Tasmanian/examples/"
        FILES_MATCHING PATTERN "*.cpp"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

=== Doxygen/CMakeLists.txt ===
find_package(Doxygen REQUIRED OPTIONAL_COMPONENTS dot)

set(DOXYGEN_GENERATE_HTML      "YES")
set(DOXYGEN_DISABLE_INDEX       "NO")
set(DOXYGEN_GENERATE_TREEVIEW   "YES") # left-hand index
set(DOXYGEN_SORT_GROUP_NAMES    "NO") # disable automatic sorting
set(DOXYGEN_SORT_MEMBER_DOCS    "NO") # use the order in the source files (logical order)
set(DOXYGEN_SORT_BRIEF_DOCS     "NO") # which is more logical than the alphabetical one

# skip sections marked with __TASMANIAN_DOXYGEN_SKIP to avoid extraneous warnings
# document all options regardless of the build, mostly affects the internal API
set(DOXYGEN_PREDEFINED "__TASMANIAN_DOXYGEN_SKIP;Tasmanian_ENABLE_BLAS;Tasmanian_ENABLE_CUDA;Tasmanian_ENABLE_MPI")

set(DOXYGEN_HTML_EXTRA_STYLESHEET  ${CMAKE_CURRENT_SOURCE_DIR}/tasmanian.css)
set(DOXYGEN_HTML_HEADER "${CMAKE_CURRENT_SOURCE_DIR}/header.html")
set(DOXYGEN_HTML_FOOTER "${CMAKE_CURRENT_SOURCE_DIR}/footer.html")
set(DOXYGEN_HTML_COLORSTYLE_HUE    "175") # green-ish pages
set(DOXYGEN_HTML_COLORSTYLE_SAT    "50")
set(DOXYGEN_HTML_COLORSTYLE_GAMMA  "90")


set(DOXYGEN_FORMULA_FONTSIZE "14")
set(DOXYGEN_USE_MATHJAX "NO")

set(DOXYGEN_PROJECT_NAME   "Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN: ${PROJECT_NAME} v${Tasmanian_VERSION_MAJOR}.${Tasmanian_VERSION_MINOR}${Tasmanian_version_comment}")
set(DOXYGEN_PROJECT_NUMBER "") # if project number is given, the rendered font is too small

set(DOXYGEN_EXAMPLE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../") # finding the examples for all modules requires the use of the root dir

if (NOT DOXYGEN_INTERNAL_DOCS)
# the \internal command works for functions and namespaces, but not classes
# have to exclude the classes manually
    set(DOXYGEN_EXCLUDE_SYMBOLS TasGrid::Data2D TasGrid::MultiIndexSet TasGrid::StorageSet TasGrid::CustomTabulated TasGrid::OneDimensionalWrapper
        TasGrid::TasSparse::WaveletBasisMatrix TasGrid::GpuEngine TasGrid::GpuVector TasGrid::AccelerationDomainTransform
        TasGrid::AccelerationContext TasGrid::TableGaussPatterson TasGrid::InternalSyclQueue
        TasBLAS TasGrid::TasmanianDenseSolver TasGrid::TasmanianTridiagonalSolver TasGrid::Utils
        TasGrid::NodeData TasGrid::TensorData TasGrid::CacheLagrange TasGrid::CacheLagrangeDerivative
        TasGrid::MultiIndexManipulations::ProperWeights
        TasGrid::HierarchyManipulations::SplitDirections
        TasGrid::Utils::Wrapper2D TasGrid::SimpleConstructData TasGrid::DynamicConstructorDataGlobal
        TasGrid::Optimizer::CurrentNodes TasGrid::Optimizer::HasDerivative TasGrid::Optimizer::OptimizerResult
        TasGrid::VectorToStreamBuffer TasGrid::CandidateManager TasGrid::CompleteStorage
        TasGrid::IO::mode_ascii_type TasGrid::IO::mode_binary_type TasGrid::HandleDeleter
        TasGrid::AccHandle::Cublas TasGrid::AccHandle::Cusparse TasGrid::AccHandle::Cusolver
        TasGrid::AccHandle::Rocblas TasGrid::AccHandle::Rocsparse TasGrid::AccHandle::Syclqueue
        TasGrid::tsg_gpu_selector TasGrid::int_gpu_lapack
        TasDREAM::IO TasDREAM::Utils)
    set(DOXYGEN_PREDEFINED "__TASMANIAN_DOXYGEN_SKIP;__TASMANIAN_DOXYGEN_SKIP_INTERNAL;Tasmanian_ENABLE_BLAS;Tasmanian_ENABLE_CUDA;Tasmanian_ENABLE_DPCPP;Tasmanian_ENABLE_HIP;Tasmanian_ENABLE_MPI")
endif()

### Add the git-hash to the main page, suppress at release (the stable page needs no hash)
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/../README.md" Tasmanian_readme)
string(REPLACE "# Tasmanian" "# Tasmanian\n    * *Generated from git commit ${Tasmanian_git_hash}*" Tasmanian_readme ${Tasmanian_readme})
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/README.md" "${Tasmanian_readme}")
set(DOXYGEN_USE_MDFILE_AS_MAINPAGE "${CMAKE_CURRENT_BINARY_DIR}/README.md")

doxygen_add_docs(Tasmanian_doxygen
                 ${CMAKE_CURRENT_BINARY_DIR}/README.md
                 Doxygen/Contributors.md
                 Doxygen/Installation.md
                 Doxygen/InterfacePython.md
                 Doxygen/InterfaceLibEnsemble.md
                 Doxygen/InterfaceCLI.md
                 Doxygen/InterfaceMATLAB.md
                 Doxygen/InterfaceFortran2003.md
                 Doxygen/CustomRuleFileFormat.md
                 Config/Tasmanian.hpp
                 SparseGrids/TasmanianSparseGrid.hpp
                 DREAM/TasmanianDREAM.hpp
                 DREAM/Optimization/TasmanianOptimization.hpp
                 Addons/TasmanianAddons.hpp
                 SparseGrids/tsgEnumerates.hpp
                 SparseGrids/tsgUtils.hpp
                 SparseGrids/tsgMathUtils.hpp
                 SparseGrids/tsgIndexSets.hpp
                 SparseGrids/tsgIndexManipulator.hpp
                 SparseGrids/tsgIndexManipulator.cpp
                 SparseGrids/tsgHierarchyManipulator.hpp
                 SparseGrids/tsgIOHelpers.hpp
                 SparseGrids/tsgAcceleratedHandles.hpp
                 SparseGrids/tsgAcceleratedDataStructures.hpp
                 SparseGrids/tsgCudaLoadStructures.hpp
                 SparseGrids/tsgCacheLagrange.hpp
                 SparseGrids/tsgCoreOneDimensional.hpp
                 SparseGrids/tsgOneDimensionalWrapper.hpp
                 SparseGrids/tsgHardCodedTabulatedRules.hpp
                 SparseGrids/tsgLinearSolvers.hpp
                 SparseGrids/tsgDConstructGridGlobal.hpp
                 SparseGrids/tsgSequenceOptimizer.hpp
                 SparseGrids/tsgSequenceOptimizer.cpp
                 SparseGrids/tsgRuleWavelet.hpp
                 SparseGrids/tsgRuleLocalPolynomial.hpp
                 SparseGrids/tsgGridCore.hpp
                 SparseGrids/tsgGridGlobal.hpp
                 SparseGrids/tsgGridSequence.hpp
                 SparseGrids/tsgGridLocalPolynomial.hpp
                 SparseGrids/tsgGridWavelet.hpp
                 SparseGrids/tsgGridFourier.hpp
                 DREAM/tsgDreamState.hpp
                 DREAM/tsgDreamSample.hpp
                 DREAM/tsgDreamEnumerates.hpp
                 DREAM/tsgDreamCoreRandom.hpp
                 DREAM/tsgDreamCorePDF.hpp
                 DREAM/tsgDreamLikelihoodCore.hpp
                 DREAM/tsgDreamLikelyGaussian.hpp
                 DREAM/Optimization/tsgParticleSwarm.hpp
                 DREAM/Optimization/tsgGradientDescent.hpp
                 DREAM/Optimization/tsgOptimizationUtils.hpp
                 Addons/tsgExoticQuadrature.hpp
                 Addons/tsgConstructSurrogate.hpp
                 Addons/tsgCandidateManager.hpp
                 Addons/tsgLoadUnstructuredPoints.hpp
                 Addons/tsgMPIConstructGrid.hpp
                 Addons/tsgMPISampleDream.hpp
                 Addons/tsgMPIScatterDream.hpp
                 Addons/tsgMPIScatterGrid.hpp
                 Addons/tsgLoadNeededValues.hpp
                 Addons/tsgAddonsCommon.hpp
                 InterfaceTPL/tsgTPLWrappers.hpp
                 InterfaceTPL/tsgBlasWrappers.hpp
                 InterfaceTPL/tsgGpuWrappers.hpp
                 SparseGrids/Examples/example_sparse_grids.cpp
                 SparseGrids/Examples/example_sparse_grids_01.cpp
                 SparseGrids/Examples/example_sparse_grids_02.cpp
                 SparseGrids/Examples/example_sparse_grids_03.cpp
                 SparseGrids/Examples/example_sparse_grids_04.cpp
                 SparseGrids/Examples/example_sparse_grids_05.cpp
                 SparseGrids/Examples/example_sparse_grids_06.cpp
                 SparseGrids/Examples/example_sparse_grids_07.cpp
                 SparseGrids/Examples/example_sparse_grids_08.cpp
                 SparseGrids/Examples/example_sparse_grids_09.cpp
                 SparseGrids/Examples/example_sparse_grids_10.cpp
                 SparseGrids/Examples/example_sparse_grids_11.cpp
                 DREAM/Examples/example_dream.cpp
                 DREAM/Examples/example_dream_01.cpp
                 DREAM/Examples/example_dream_02.cpp
                 DREAM/Examples/example_dream_03.cpp
                 DREAM/Examples/example_dream_04.cpp
                 DREAM/Examples/example_dream_05.cpp
                 DREAM/Examples/example_optimization.cpp
                 DREAM/Examples/example_optimization_01.cpp
                 DREAM/Examples/example_optimization_02.cpp
                 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
                 COMMENT "Tasmanian Doxygen documentation")

# doxygen_add_docs() doesn't add the target to "all"
# need to manually add dependence to ensure the docs are build before "install"
# adding Tasmanian_doxygen to both sparse grids libraries forces the docs to be build first
# even if parallel build is used (e.g., make -j) this will keep the c++ and doxygen outputs separate
add_dependencies(Tasmanian_libsparsegrid  Tasmanian_doxygen)


install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION "share/Tasmanian/docs")

=== InterfaceFortran/CMakeLists.txt ===
########################################################################
# Fortran librareis and command line tools
########################################################################

add_library(Tasmanian_libfortran90 TasmanianSG.f90
                                   tsgC2FortranBridge.f90
                                   tsgC2Fortran.cpp)

target_include_directories(Tasmanian_libfortran90 PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/>)
target_link_libraries(Tasmanian_libfortran90  Tasmanian_addons)

set_target_properties(Tasmanian_libfortran90 PROPERTIES OUTPUT_NAME "tasmanianfortran90"
                                             SOVERSION ${Tasmanian_VERSION_MAJOR}
                                             VERSION   ${PROJECT_VERSION})
Tasmanian_rpath_target(TARGET Tasmanian_libfortran90 COMPONENTS SparseGrids DREAM)

install(TARGETS Tasmanian_libfortran90
        EXPORT "${Tasmanian_export_name}"
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "lib"
        ARCHIVE DESTINATION "lib")


########################################################################
# add the fortran tester and examples executables
########################################################################
add_executable(Tasmanian_fortester fortester.f90)

set_target_properties(Tasmanian_fortester  PROPERTIES OUTPUT_NAME "fortester" LINKER_LANGUAGE Fortran)
Tasmanian_rpath_target(TARGET Tasmanian_fortester USE_CURRENT COMPONENTS SparseGrids DREAM)

target_link_libraries(Tasmanian_fortester  Tasmanian_libfortran90)


########################################################################
# handle the MPI dependence and MPI tests
########################################################################
if (Tasmanian_ENABLE_MPI)
    target_link_libraries(Tasmanian_libfortran90 MPI::MPI_Fortran)

    add_executable(Tasmanian_mpif90    mpitester.f90)
    set_target_properties(Tasmanian_mpif90     PROPERTIES OUTPUT_NAME "mpitester" LINKER_LANGUAGE Fortran)
    target_link_libraries(Tasmanian_mpif90     Tasmanian_libfortran90)
    add_test(MPIFortranGridIO ${MPIEXEC_EXECUTABLE} ${MPIEXEC_NUMPROC_FLAG} 3 ${MPIEXEC_PREFLAGS} ${CMAKE_CURRENT_BINARY_DIR}/mpitester ${MPIEXEC_POSTFLAGS})
    set_tests_properties(MPIFortranGridIO PROPERTIES RUN_SERIAL ON)
    Tasmanian_set_test_properties(TESTS MPIFortranGridIO)
endif()


########################################################################
# Testing
########################################################################
add_test(Fortran90 fortester)
Tasmanian_set_test_properties(TESTS Fortran90)


########################################################################
# Installation
########################################################################
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tasmaniansg.mod"
        DESTINATION include
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)

=== InterfaceMATLAB/CMakeLists.txt ===
########################################################################
# MATLAB interface, examples and tests
########################################################################

set(Tasmanian_matlab_source_files tsgCancelRefine.m
                                  tsgCleanTempFiles.m
                                  tsgCopyGrid.m
                                  tsgDeleteGridByName.m
                                  tsgDeleteGrid.m
                                  tsgDifferentiate.m
                                  tsgEstimateAnisotropicCoefficients.m
                                  tsgEvaluateHierarchy.m
                                  tsgEvaluate.m
                                  tsgExample.m
                                  tsgGetCandidateConstructionAnisotropic.m
                                  tsgGetCandidateConstructionSurplus.m
                                  tsgGetHCoefficients.m
                                  tsgGetHSupport.m
                                  tsgGetInterpolationWeights.m
                                  tsgGetDifferentiationWeights.m
                                  tsgGetNeededIndexes.m
                                  tsgGetNeededPoints.m
                                  tsgGetPointsIndexes.m
                                  tsgGetPoints.m
                                  tsgGetPolynomialSpaces.m
                                  tsgGetQuadrature.m
                                  tsgIntegrate.m
                                  tsgListGridsByName.m
                                  tsgLoadConstructedPoints.m
                                  tsgLoadGridFromFile.m
                                  tsgLoadHCoefficients.m
                                  tsgLoadValues.m
                                  tsgMakeExoticQuadrature.m
                                  tsgMakeFilenames.m
                                  tsgMakeFourier.m
                                  tsgMakeGlobal.m
                                  tsgMakeGridFilename.m
                                  tsgMakeLocalPolynomial.m
                                  tsgMakeQuadrature.m
                                  tsgMakeSequence.m
                                  tsgMakeWavelet.m
                                  tsgMergeRefine.m
                                  tsgPlotPoints2D.m
                                  tsgReadCustomRuleFile.m
                                  tsgReadMatrix.m
                                  tsgRefineAnisotropic.m
                                  tsgRefineSurplus.m
                                  tsgReloadGrid.m
                                  tsgSummary.m
                                  tsgUsingConstruction.m
                                  tsgCoreTests.m
                                  tsgWriteCustomRuleFile.m
                                  tsgWriteMatrix.m)

# configure_file() command causes update to the entire CMake environment, if the file changes
# using copy will copy the files on change but will not reconfigure the environment
foreach(Tasmanian_matlab_source_file ${Tasmanian_matlab_source_files})
    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/matlab/${Tasmanian_matlab_source_file}"
                       COMMAND "${CMAKE_COMMAND}"
                       ARGS -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${Tasmanian_matlab_source_file}" "${CMAKE_CURRENT_BINARY_DIR}/matlab/${Tasmanian_matlab_source_file}"
                       DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${Tasmanian_matlab_source_file}"
                       COMMENT "Copying ${CMAKE_CURRENT_SOURCE_DIR}/${Tasmanian_matlab_source_file}")
    list(APPEND Tasmanian_matlab_pre_install_files "${CMAKE_CURRENT_BINARY_DIR}/matlab/${Tasmanian_matlab_source_file}")
endforeach()
add_custom_target(Tasmanian_matlab_interface ALL DEPENDS "${Tasmanian_matlab_pre_install_files}")

# set MATLAB (tasgrid and temp folder) for the build folder (stage 1)
file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/tempMATLAB/") # place for temp files if running matlab from the build location
set(Tasmanian_matlab_tasgrid "${CMAKE_CURRENT_BINARY_DIR}/../Tasgrid/tasgrid")
string(REPLACE " " "\\ " Tasmanian_matlab_tasgrid "${Tasmanian_matlab_tasgrid}")
set(Tasmanian_matlab_workdir "${CMAKE_CURRENT_BINARY_DIR}/tempMATLAB/")
string(REPLACE " " "\\ " Tasmanian_matlab_workdir "${Tasmanian_matlab_workdir}")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/tsgGetPaths.build.m" "${CMAKE_CURRENT_BINARY_DIR}/matlab/tsgGetPaths.m" @ONLY)

# set MATLAB (tasgrid and temp folder) for the install folder (stage 2)
set(Tasmanian_matlab_tasgrid "${Tasmanian_final_install_path}/bin/tasgrid")
string(REPLACE " " "\\ " Tasmanian_matlab_tasgrid "${Tasmanian_matlab_tasgrid}")
#message("${Tasmanian_matlab_tasgrid}") # sanity check, especially if spaces are present in folder names
set(Tasmanian_matlab_workdir "${Tasmanian_MATLAB_WORK_FOLDER}/")
string(REPLACE " " "\\ " Tasmanian_matlab_workdir "${Tasmanian_matlab_workdir}")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/tsgGetPaths.install.m" "${CMAKE_CURRENT_BINARY_DIR}/configured/tsgGetPaths.m" @ONLY)

# test if we can find the octave executable and we can get the version
# do not test with MATLAB to avoid potential license issues
find_program(Tasmanian_OCTAVE_EXECUABLE NAMES octave)
if (Tasmanian_OCTAVE_EXECUABLE)
    execute_process(COMMAND octave --version OUTPUT_QUIET RESULT_VARIABLE Tasmanian_octave_works)
    if ("${Tasmanian_octave_works}" STREQUAL 0)
        add_test(TasmanianOctave octave --eval "addpath('${CMAKE_CURRENT_BINARY_DIR}/matlab'); tsgCoreTests()")
    endif()
endif()

# create the MATLAB work-folder on install
install(CODE "file(MAKE_DIRECTORY \"${Tasmanian_MATLAB_WORK_FOLDER}\")")

# installed files
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
        DESTINATION "share/Tasmanian/matlab/"
        FILES_MATCHING PATTERN "*.m"
        PATTERN "tsgGetPaths.*" EXCLUDE)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/configured/tsgGetPaths.m"
        DESTINATION "share/Tasmanian/matlab/"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

=== InterfacePython/CMakeLists.txt ===
########################################################################
# Python module, examples and tests
#
# Configure the .in. files using three stage configuration
#   stage 1: everything (build, test, etc) should work in the build folder
#   stage 2: everything should work after make install
#
########################################################################

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    set(Tasmanian_python_default_path "${CMAKE_INSTALL_PREFIX}/python${Python_VERSION_MAJOR}${Python_VERSION_MINOR}/site-packages")
else()
    set(Tasmanian_python_default_path "${CMAKE_INSTALL_PREFIX}/lib/python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages")
endif()

if (NOT "${Tasmanian_python_install_path}" STREQUAL "${Tasmanian_python_default_path}")
    set(Tasmanian_python_install_path "${Tasmanian_python_default_path}" CACHE INTERNAL "install path for the Python module (version specific)" FORCE)
    set(Tasmanian_PYTHONPATH "${CMAKE_INSTALL_PREFIX}/share/Tasmanian/python/" CACHE PATH "install path for the Python module (version independent)" FORCE)
endif()

# CMake has permissive implementation of boolean true, which includes
# "On", "True" and "Yes" with different cases;
# Here we convert boolen true to "ON" so it can
# be safely passed to Python as a string and interpreted via
# python_boolean = ("@cmake_boolean@" == "ON")
foreach(_tsg_opt Tasmanian_ENABLE_BLAS Tasmanian_ENABLE_CUDA Tasmanian_ENABLE_HIP Tasmanian_ENABLE_DPCPP)
    if (${_tsg_opt})
        set(${_tsg_opt} "ON")
    endif()
endforeach()
unset(_tsg_opt)


########################################################################
# Stage 1: Build folder paths
########################################################################
set(Tasmanian_string_python_hashbang "${Python_EXECUTABLE}")

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
# windows puts the temp .dll files in Release or Debug subfolder, as opposed to directly in ${CMAKE_CURRENT_BINARY_DIR}
# add different configure file for each build type and copy the appropriate one with a custom command
    foreach(_tsg_configtype Release Debug)
        set(Tasmanian_libsparsegrid_path "${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/${_tsg_configtype}/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniansparsegrid${CMAKE_SHARED_LIBRARY_SUFFIX}")
        set(Tasmanian_libdream_path      "${CMAKE_CURRENT_BINARY_DIR}/../DREAM/${_tsg_configtype}/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniandream${CMAKE_SHARED_LIBRARY_SUFFIX}")
        set(Tasmanian_libcaddons_path    "${CMAKE_CURRENT_BINARY_DIR}/../Addons/${_tsg_configtype}/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniancaddons${CMAKE_SHARED_LIBRARY_SUFFIX}")
        # all libraries that are needed transitively must be included here, currently on the sparse grid library is needed
        set(Tasmanian_libpaths           "${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/${_tsg_configtype}/")

        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/testConfigureData.in.py"  "${CMAKE_CURRENT_BINARY_DIR}/testConfigureData${_tsg_configtype}.py")
        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/TasmanianConfig.in.py"    "${CMAKE_CURRENT_BINARY_DIR}/TasmanianConfig${_tsg_configtype}.py")

        list(APPEND Tasmanian_python_files  "${CMAKE_CURRENT_BINARY_DIR}/testConfigureData${_tsg_configtype}.py"
                                            "${CMAKE_CURRENT_BINARY_DIR}/TasmanianConfig${_tsg_configtype}.py")
    endforeach()
    unset(_tsg_configtype)

    add_custom_target(Tasmanian_python_interface ALL DEPENDS ${Tasmanian_python_files})
    unset(Tasmanian_python_files)

    add_custom_command(TARGET Tasmanian_python_interface PRE_BUILD
                       COMMAND "${CMAKE_COMMAND}"
                       ARGS -E copy ${CMAKE_CURRENT_BINARY_DIR}/TasmanianConfig$<CONFIG>.py ${CMAKE_CURRENT_BINARY_DIR}/TasmanianConfig.py
                       COMMENT "Copying Python module for config $<CONFIG>")
    add_custom_command(TARGET Tasmanian_python_interface PRE_BUILD
                       COMMAND "${CMAKE_COMMAND}"
                       ARGS -E copy ${CMAKE_CURRENT_BINARY_DIR}/testConfigureData$<CONFIG>.py ${CMAKE_CURRENT_BINARY_DIR}/testConfigureData.py
                       COMMENT "Copying Python module for config $<CONFIG>")
else()
    set(Tasmanian_libsparsegrid_path "${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniansparsegrid${CMAKE_SHARED_LIBRARY_SUFFIX}")
    set(Tasmanian_libdream_path      "${CMAKE_CURRENT_BINARY_DIR}/../DREAM/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniandream${CMAKE_SHARED_LIBRARY_SUFFIX}")
    set(Tasmanian_libcaddons_path    "${CMAKE_CURRENT_BINARY_DIR}/../Addons/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniancaddons${CMAKE_SHARED_LIBRARY_SUFFIX}")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/testConfigureData.in.py"  "${CMAKE_CURRENT_BINARY_DIR}/testConfigureData.py")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/TasmanianConfig.in.py"    "${CMAKE_CURRENT_BINARY_DIR}/TasmanianConfig.py")
endif()

set(Tasmanian_python_example_import "sys.path.append(\"${CMAKE_CURRENT_BINARY_DIR}\")\n")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/example_sparse_grids.in.py" "${CMAKE_CURRENT_BINARY_DIR}/example_sparse_grids.py") # also uses Tasmanian_string_python_hashbang
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/example_dream.in.py" "${CMAKE_CURRENT_BINARY_DIR}/example_dream.py") # also uses Tasmanian_string_python_hashbang
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/example_optimization.in.py" "${CMAKE_CURRENT_BINARY_DIR}/example_optimization.py") # also uses Tasmanian_string_python_hashbang

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sandbox.py" "${CMAKE_CURRENT_BINARY_DIR}/sandbox.py") # only uses Tasmanian_string_python_hashbang

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/GaussPattersonRule.table"  "${CMAKE_CURRENT_BINARY_DIR}/GaussPattersonRule.table" COPYONLY) # needed for testing

# See the matlab CMakeText.txt on how to copy multiple scripts
set(Tasmanian_python_test_files TasmanianSG.py TasmanianAddons.py Tasmanian.py
                                TasmanianDREAM.py TasmanianDreamLikely.py TasmanianDreamState.py TasmanianDreamSampler.py
                                TasmanianOPT.py TasmanianParticleSwarm.py TasmanianGradientDescent.py
                                testTSG.py testCommon.py testBasicIO.py testAcceleration.py testExceptions.py testMakeUpdate.py
                                testRefinement.py testUnstructuredData.py testMisc.py testAddons.py testDream.py testOptimization.py
                                example_sparse_grids_01.py example_sparse_grids_02.py example_sparse_grids_03.py
                                example_sparse_grids_04.py example_sparse_grids_05.py example_sparse_grids_06.py
                                example_sparse_grids_07.py example_sparse_grids_08.py example_sparse_grids_09.py
                                example_sparse_grids_10.py example_sparse_grids_11.py
                                example_dream_01.py example_dream_02.py example_dream_03.py example_dream_04.py example_dream_05.py
                                example_optimization_01.py example_optimization_02.py
                                )

foreach(Tasmanian_python_testing_file ${Tasmanian_python_test_files})
    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${Tasmanian_python_testing_file}"
                       COMMAND "${CMAKE_COMMAND}"
                       ARGS -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${Tasmanian_python_testing_file} ${CMAKE_CURRENT_BINARY_DIR}//${Tasmanian_python_testing_file}
                       DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${Tasmanian_python_testing_file}"
                       COMMENT "Copying ${CMAKE_CURRENT_SOURCE_DIR}/${Tasmanian_python_testing_file}")
    list(APPEND Tasmanian_python_testing_files_stage1 "${CMAKE_CURRENT_BINARY_DIR}/${Tasmanian_python_testing_file}")
endforeach()
unset(Tasmanian_python_testing_file)
add_custom_target(Tasmanian_python_testing ALL DEPENDS "${Tasmanian_python_testing_files_stage1}")


########################################################################
# Stage 2: Install folder paths
########################################################################
set(Tasmanian_shared_lib_destination "lib")
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows") # windows puts the .dll files in bin, as opposed to lib
    set(Tasmanian_shared_lib_destination "bin")
endif()

set(Tasmanian_libsparsegrid_path "${Tasmanian_final_install_path}/${Tasmanian_shared_lib_destination}/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniansparsegrid${CMAKE_SHARED_LIBRARY_SUFFIX}")
set(Tasmanian_libdream_path      "${Tasmanian_final_install_path}/${Tasmanian_shared_lib_destination}/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniandream${CMAKE_SHARED_LIBRARY_SUFFIX}")
set(Tasmanian_libcaddons_path    "${Tasmanian_final_install_path}/${Tasmanian_shared_lib_destination}/${CMAKE_SHARED_LIBRARY_PREFIX}tasmaniancaddons${CMAKE_SHARED_LIBRARY_SUFFIX}")
set(Tasmanian_libpaths           "${Tasmanian_final_install_path}/bin/")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/TasmanianConfig.in.py"  "${CMAKE_CURRENT_BINARY_DIR}/configured/TasmanianConfig.py")


set(Tasmanian_python_example_import "sys.path.append(\"${Tasmanian_python_install_path}\")\n")
if (SKBUILD)
    set(Tasmanian_python_example_import "") # if installed through pip, no path is needed
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/example_sparse_grids.in.py" "${CMAKE_CURRENT_BINARY_DIR}/configured/example_sparse_grids.py") # also uses Tasmanian_string_python_hashbang
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/example_dream.in.py" "${CMAKE_CURRENT_BINARY_DIR}/configured/example_dream.py") # also uses Tasmanian_string_python_hashbang
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/example_optimization.in.py" "${CMAKE_CURRENT_BINARY_DIR}/configured/example_optimization.py") # also uses Tasmanian_string_python_hashbang


########################################################################
# Testing
########################################################################
add_test(NAME PythonIO           COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testBasicIO)
add_test(NAME PythonAcceleration COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testAcceleratedEvaluate)
add_test(NAME PythonExceptions   COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testBasicException)
add_test(NAME PythonMakeUpdate   COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testAMakeUpdate)
add_test(NAME PythonRefine       COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testBRefinement)
add_test(NAME PythonLearning     COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testCUnsructuredData)
add_test(NAME PythonMisc         COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testZMisc)
add_test(NAME PythonAddons       COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testAddons)
add_test(NAME PythonDream        COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testDream)
add_test(NAME PythonOptimization COMMAND Python::Interpreter "${CMAKE_CURRENT_BINARY_DIR}/testTSG.py" TestTasmanian.testOptimization)
set_tests_properties(PythonIO PROPERTIES RUN_SERIAL ON) # IO and Refine read/write to potentially the same files
set_tests_properties(PythonRefine PROPERTIES RUN_SERIAL ON)
Tasmanian_set_test_properties(TESTS PythonIO PythonAcceleration PythonExceptions PythonMakeUpdate PythonRefine PythonLearning PythonMisc PythonAddons PythonDream)


########################################################################
# Windows system paths
########################################################################
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

=== InterfaceSwig/CMakeLists.txt ===
if (Tasmanian_ENABLE_SWIG)
    find_package(SWIG COMPONENTS fortran REQUIRED)

    # SWIG is requested and available; make sure it's the Fortran fork.
    cmake_policy(SET CMP0078 "NEW")
    cmake_policy(SET CMP0086 "NEW")
    include(UseSWIG)
endif()

set(Tasmanian_GENERATE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/generated")

# usage: Tasmanian_set_fortran_props(TARGET Tasmanian_libdream OUTPUT_NAME "tasmanianfortran")
# sets the common properties of Tasmanian Fortran targets
macro(Tasmanian_set_fortran_props)
    cmake_parse_arguments(Tasmanian_fprop "" "TARGET;OUTPUT_NAME" "" ${ARGN})
    target_link_libraries(${Tasmanian_fprop_TARGET} Tasmanian_addons)
    set_target_properties(${Tasmanian_fprop_TARGET} PROPERTIES
                                                    OUTPUT_NAME ${Tasmanian_fprop_OUTPUT_NAME}
                                                    INSTALL_RPATH "${Tasmanian_rpath}"
                                                    SOVERSION ${Tasmanian_VERSION_MAJOR}
                                                    VERSION   ${PROJECT_VERSION})
    target_include_directories(${Tasmanian_fprop_TARGET} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/>)

    if (Tasmanian_ENABLE_MPI)
        # see the comments in the Addons/CMakeLists.txt
        target_link_libraries(${Tasmanian_fprop_TARGET} MPI::MPI_Fortran)
    endif()

    unset(Tasmanian_fprop_TARGET)
    unset(Tasmanian_fprop_OUTPUT_NAME)
endmacro()

function(tasmanian_add_swig_module tsg_name)
#
# Generates the wrappers using SWIG
#
    # SWIG is available; actually generate the library dynamically.
    set(src_file "${CMAKE_CURRENT_SOURCE_DIR}/${tsg_name}.i")
    # We're using C++
    set_property(SOURCE "${src_file}" PROPERTY CPLUSPLUS ON)
    # We need to include the source directory
    set_property(SOURCE "${src_file}" PROPERTY USE_TARGET_INCLUDE_DIRECTORIES ON)

    # Create the library (testing the generated wrappers)
    swig_add_library(${tsg_name}
      LANGUAGE Fortran
      TYPE USE_BUILD_SHARED_LIBS
      OUTPUT_DIR "${Tasmanian_GENERATE_DIR}"
      SOURCES "${src_file}" ${ARGN}
    )

    Tasmanian_set_fortran_props(TARGET ${tsg_name} OUTPUT_NAME ${tsg_name})

endfunction()

macro(Tasmanian_macro_add_libdfortran03)
#
# Build the Fortran module from an existing generated source file
#   - there is a hack here that adds a new methods inside the TasmanianSparseGrid class
#   - the generated files are read, then modified, then written to a "regenerated" folder
#   - only the updated files are compiled
#   - the original SWIG modules all have _swig in their names, the regenerated ones don't

    file(READ "${Tasmanian_GENERATE_DIR}/tasmanian_swig.f90" Tasmanian_generated_f90)
    string(REPLACE "module tasmanian_swig" "module tasmanian" Tasmanian_generated_f90 ${Tasmanian_generated_f90})
    string(REPLACE " type, public :: TasmanianSparseGrid
  type(SwigClassWrapper), public :: swigdata
 contains"
    "type, public :: TasmanianSparseGrid
  type(SwigClassWrapper), public :: swigdata
 contains
    procedure :: returnPoints => tsgGetPoints
    procedure :: returnLoadedPoints => tsgGetLoadedPoints
    procedure :: returnNeededPoints => tsgGetNeededPoints
    procedure :: returnQuadratureWeights => tsgGetQuadratureWeights

    procedure :: returnHierarchicalCoefficients => tsgGetHierarchicalCoefficients
    procedure :: returnComplexHierarchicalCoefficients => tsgGetComplexHierarchicalCoefficients
    procedure :: setComplexHierarchicalCoefficients => tsgSetComplexHierarchicalCoefficients
    "
    Tasmanian_generated_f90 ${Tasmanian_generated_f90})

    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/regenerated/tasmanian.f90" "${Tasmanian_generated_f90}")

    add_library(Tasmanian_libfortran03  "${CMAKE_CURRENT_BINARY_DIR}/regenerated/tasmanian.f90"
                                        "${Tasmanian_GENERATE_DIR}/tasmanian_swigFORTRAN_wrap.cxx")

    Tasmanian_set_fortran_props(TARGET Tasmanian_libfortran03 OUTPUT_NAME "tasmanianfortran")
    Tasmanian_rpath_target(TARGET Tasmanian_libfortran03)

    install(TARGETS Tasmanian_libfortran03
            EXPORT "${Tasmanian_export_name}"
            RUNTIME DESTINATION "bin"
            LIBRARY DESTINATION "lib"
            ARCHIVE DESTINATION "lib")

    if (Tasmanian_ENABLE_MPI)
        file(READ "${Tasmanian_GENERATE_DIR}/tasmanian_mpi_swig.f90" Tasmanian_generated_f90)
        string(REPLACE "module tasmanian_mpi_swig" "module tasmanian_mpi" Tasmanian_generated_f90 ${Tasmanian_generated_f90})
        string(REPLACE "use tasmanian_swig" "use tasmanian" Tasmanian_generated_f90 ${Tasmanian_generated_f90})

        file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/regenerated/tasmanian_mpi.f90" "${Tasmanian_generated_f90}")

        add_library(Tasmanian_libfortranmpi03  "${CMAKE_CURRENT_BINARY_DIR}/regenerated/tasmanian_mpi.f90"
                                               "${Tasmanian_GENERATE_DIR}/tasmanian_mpi_swigFORTRAN_wrap.cxx")

        Tasmanian_set_fortran_props(TARGET Tasmanian_libfortranmpi03 OUTPUT_NAME "tasmanianfortranmpi")
        Tasmanian_rpath_target(TARGET Tasmanian_libfortranmpi03)
        target_link_libraries(Tasmanian_libfortranmpi03  Tasmanian_libfortran03)

        install(TARGETS Tasmanian_libfortranmpi03
                EXPORT "${Tasmanian_export_name}"
                RUNTIME DESTINATION "bin"
                LIBRARY DESTINATION "lib"
                ARCHIVE DESTINATION "lib")
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tasmanian_mpi.mod"
                DESTINATION include
                PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
    endif()

endmacro()

########################################################################
# Fortran librareis and command line tools
########################################################################

add_executable(Tasmanian_fortran_swig_tester ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/fortranswigtester.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_common.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_make_grid.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_domain.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_evaluate.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_update_grid.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_refinement.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_hierarchy.f90
                                             )
set_target_properties(Tasmanian_fortran_swig_tester PROPERTIES OUTPUT_NAME "forswigtester")
Tasmanian_set_fortran_linker(TARGET Tasmanian_fortran_swig_tester)

if (Tasmanian_ENABLE_SWIG)
    # generate the interface
    tasmanian_add_swig_module(tasmanian_swig)
    if (Tasmanian_ENABLE_MPI)
        tasmanian_add_swig_module(tasmanian_mpi_swig)
        target_link_libraries(tasmanian_mpi_swig  tasmanian_swig)
    endif()
endif()

Tasmanian_macro_add_libdfortran03()

target_link_libraries(Tasmanian_fortran_swig_tester  Tasmanian_libfortran03)

add_test(Fortran2003 forswigtester)
Tasmanian_set_test_properties(TESTS Fortran2003)
Tasmanian_rpath_target(TARGET Tasmanian_fortran_swig_tester USE_CURRENT COMPONENTS SparseGrids DREAM)

if (Tasmanian_ENABLE_MPI)
    add_executable(Tasmanian_fortran_mpiswig_tester ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/mpitester.f90
                                                    ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_common.f90
                                                    )
    set_target_properties(Tasmanian_fortran_mpiswig_tester PROPERTIES OUTPUT_NAME "mpiforswigtester")
    Tasmanian_rpath_target(TARGET Tasmanian_fortran_mpiswig_tester USE_CURRENT COMPONENTS SparseGrids DREAM)
    Tasmanian_set_fortran_linker(TARGET Tasmanian_fortran_mpiswig_tester)

    target_link_libraries(Tasmanian_fortran_mpiswig_tester  Tasmanian_libfortranmpi03)

    add_test(MPIFortran2003 ${MPIEXEC_EXECUTABLE} ${MPIEXEC_NUMPROC_FLAG} 3 ${MPIEXEC_PREFLAGS} ${CMAKE_CURRENT_BINARY_DIR}/mpiforswigtester ${MPIEXEC_POSTFLAGS})
    set_tests_properties(MPIFortran2003 PROPERTIES RUN_SERIAL ON)
    Tasmanian_set_test_properties(TESTS MPIFortran2003)
endif()

########################################################################
# Installation
########################################################################

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tasmanian.mod"
        DESTINATION include
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/FortranExamples/"
        DESTINATION "share/Tasmanian/examples/"
        FILES_MATCHING PATTERN "*.f90"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

=== SparseGrids/CMakeLists.txt ===
########################################################################
# Sparse Grid libraries and gridtest command line tool
########################################################################

########################################################################
# Define source files
# in order to avoid GLOB, list all source files for add_library()
########################################################################
# source files specific to cuda/hip, used for both static and shared libs
set(Tasmanian_source_libsparsegrid_cuda
       ${CMAKE_CURRENT_SOURCE_DIR}/../InterfaceTPL/tsgCudaWrappers.cpp
       tsgCudaKernels.cu)
set(Tasmanian_source_libsparsegrid_hip
       ${CMAKE_CURRENT_SOURCE_DIR}/../InterfaceTPL/tsgHipWrappers.cpp
       tsgHipKernels.hip.cpp)

set(Tasmanian_sparse_grid_null_backend ON)
if (Tasmanian_ENABLE_CUDA OR Tasmanian_ENABLE_HIP OR Tasmanian_ENABLE_DPCPP)
    set(Tasmanian_sparse_grid_null_backend OFF)
endif()

add_library(Tasmanian_libsparsegrid
        TasmanianSparseGrid.hpp
        TasmanianSparseGrid.cpp
        TasmanianSparseGridWrapC.cpp
        tsgAcceleratedHandles.hpp
        tsgAcceleratedDataStructures.hpp
        tsgAcceleratedDataStructures.cpp
        tsgCacheLagrange.hpp
        tsgCoreOneDimensional.hpp
        tsgCoreOneDimensional.cpp
        tsgDConstructGridGlobal.hpp
        tsgDConstructGridGlobal.cpp
        tsgCudaLoadStructures.hpp
        tsgEnumerates.hpp
        tsgGridCore.hpp
        tsgGridGlobal.hpp
        tsgGridGlobal.cpp
        tsgGridWavelet.hpp
        tsgGridWavelet.cpp
        tsgHardCodedTabulatedRules.hpp
        tsgHardCodedTabulatedRules.cpp
        tsgGridLocalPolynomial.hpp
        tsgGridLocalPolynomial.cpp
        tsgGridSequence.hpp
        tsgGridSequence.cpp
        tsgGridFourier.hpp
        tsgGridFourier.cpp
        tsgIndexManipulator.hpp
        tsgIndexManipulator.cpp
        tsgHierarchyManipulator.hpp
        tsgHierarchyManipulator.cpp
        tsgIOHelpers.hpp
        tsgIndexSets.hpp
        tsgIndexSets.cpp
        tsgLinearSolvers.hpp
        tsgLinearSolvers.cpp
        tsgOneDimensionalWrapper.hpp
        tsgRuleLocalPolynomial.hpp
        tsgRuleWavelet.hpp
        tsgRuleWavelet.cpp
        tsgSequenceOptimizer.hpp
        tsgSequenceOptimizer.cpp
        tsgMathUtils.hpp
        tsgUtils.hpp
        $<$<BOOL:${Tasmanian_sparse_grid_null_backend}>:${CMAKE_CURRENT_SOURCE_DIR}/../InterfaceTPL/tsgGpuNull.cpp>
        $<$<BOOL:${Tasmanian_ENABLE_CUDA}>:${Tasmanian_source_libsparsegrid_cuda}>
        $<$<BOOL:${Tasmanian_ENABLE_HIP}>:${Tasmanian_source_libsparsegrid_hip}>
        $<$<BOOL:${Tasmanian_ENABLE_DPCPP}>:${CMAKE_CURRENT_SOURCE_DIR}/../InterfaceTPL/tsgDpcppWrappers.cpp>
        $<$<BOOL:${Tasmanian_ENABLE_DPCPP}>:${CMAKE_CURRENT_SOURCE_DIR}/tsgDpcppKernels.cpp>
        )

########################################################################
# add the gridtest and examples executables
########################################################################
add_executable(Tasmanian_gridtest gridtest_main.cpp
                                  TasmanianSparseGrid.hpp
                                  gridtestCLICommon.hpp
                                  gridtestExternalTests.hpp
                                  gridtestExternalTests.cpp
                                  gridtestTestHelpers.hpp
                                  gridtestTestFunctions.hpp
                                  gridtestTestFunctions.cpp
                                  gridtestUnitTests.hpp
                                  gridtestUnitTests.cpp
                                  gridtestTestInterfaceC.cpp)

add_executable(Tasmanian_benchmarksgrid  Benchmarks/benchCommon.hpp
                                         gridtestCLICommon.hpp
                                         Benchmarks/benchMakeGrid.hpp
                                         Benchmarks/benchLoadNeeded.hpp
                                         Benchmarks/benchDifferentiate.hpp
                                         Benchmarks/benchEvaluate.hpp
                                         Benchmarks/benchRefine.hpp
                                         Benchmarks/bench_main.cpp)

if (Tasmanian_ENABLE_CUDA)
    # CMake does not automatically add the CUDA include path, any source file that adds <cuda.h> directly or transitively
    # must be labeled as "CUDA" source files and compiled with the nvcc compiler.
    # Beware that the nvcc compiler seems to struggle with some STL algorithms, transitive inclusion of <cuda.h> must be minimized.
    set_source_files_properties(${Tasmanian_source_libsparsegrid_cuda} PROPERTIES LANGUAGE CUDA)
    set_property(TARGET Tasmanian_libsparsegrid PROPERTY CUDA_STANDARD 11)
elseif(Tasmanian_ENABLE_HIP)
    set_source_files_properties(${Tasmanian_source_libsparsegrid_hip} PROPERTIES LANGUAGE HIP)
elseif(Tasmanian_ENABLE_DPCPP)
    target_compile_options(Tasmanian_libsparsegrid PRIVATE -fsycl)
    target_compile_options(Tasmanian_gridtest      PRIVATE -fsycl)
    target_link_options(Tasmanian_libsparsegrid    PRIVATE -fsycl)
    target_link_options(Tasmanian_gridtest         PRIVATE -fsycl)
endif()

target_link_libraries(Tasmanian_libsparsegrid  Tasmanian_dependencies)

target_include_directories(Tasmanian_libsparsegrid PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>)

set_target_properties(Tasmanian_libsparsegrid PROPERTIES OUTPUT_NAME "tasmaniansparsegrid"
                                                         SOVERSION ${Tasmanian_VERSION_MAJOR}
                                                         VERSION   ${PROJECT_VERSION})
Tasmanian_rpath_target(TARGET Tasmanian_libsparsegrid)

if (Tasmanian_ENABLE_OPENMP)
    # the nvcc compiler does nor recognize OpenMP, add the flag only to non-CUDA source files
    target_compile_options(Tasmanian_libsparsegrid PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${OpenMP_CXX_FLAGS}>)
endif()

install(TARGETS Tasmanian_libsparsegrid
        EXPORT  "${Tasmanian_export_name}"
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "lib"
        ARCHIVE DESTINATION "lib")

foreach(_tsgtarget gridtest benchmarksgrid)
    target_link_libraries(Tasmanian_${_tsgtarget} Tasmanian_libsparsegrid)
    set_target_properties(Tasmanian_${_tsgtarget} PROPERTIES OUTPUT_NAME "${_tsgtarget}" CXX_EXTENSIONS OFF)
    Tasmanian_rpath_target(TARGET Tasmanian_${_tsgtarget} USE_CURRENT)
    if (Tasmanian_ENABLE_OPENMP)
        # the OpenMP libraries are carried transitively from sparse grids library
        target_compile_options(Tasmanian_${_tsgtarget} PRIVATE ${OpenMP_CXX_FLAGS})
    endif()
    if (Tasmanian_ENABLE_HIP)
        target_link_libraries(Tasmanian_${_tsgtarget} hip::host)
    endif()
endforeach()
unset(_tsgtarget)

# data file, needed for testing and reference about custom rule definitions
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/GaussPattersonRule.table"  "${CMAKE_CURRENT_BINARY_DIR}/GaussPattersonRule.table" COPYONLY)


########################################################################
# Windows specific support (DLL export/import directives and names)
########################################################################
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

    foreach(_tsg_target libsparsegrid gridtest)
        # suppresses warnings regarding pointers to the middle of an array
        target_compile_definitions(Tasmanian_${_tsg_target} PRIVATE -D_SCL_SECURE_NO_WARNINGS)
        # needed to prevent crash on using STL vector iterators
        target_compile_definitions(Tasmanian_${_tsg_target} PUBLIC  -D_HAS_ITERATOR_DEBUGGING=0)
    endforeach()
    unset(_tsg_target)

    if (BUILD_SHARED_LIBS)
        set_target_properties(Tasmanian_libsparsegrid PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
    endif()

endif()


########################################################################
# Testing
########################################################################
add_test(SparseGridsAcceleration gridtest acceleration -gpuid ${Tasmanian_TESTS_GPU_ID})
add_test(SparseGridsDomain       gridtest domain)
add_test(SparseGridsRefinement   gridtest refinement)
add_test(SparseGridsGlobal       gridtest global)
add_test(SparseGridsLocal        gridtest local)
add_test(SparseGridsWavelet      gridtest wavelet)
add_test(SparseGridsFourier      gridtest fourier)
add_test(SparseGridsExceptions   gridtest errors)
add_test(SparseGridsAPI          gridtest api)
add_test(SparseGridsC            gridtest c)
Tasmanian_set_test_properties(TESTS SparseGridsAcceleration SparseGridsDomain SparseGridsRefinement SparseGridsGlobal SparseGridsLocal SparseGridsWavelet SparseGridsFourier SparseGridsExceptions SparseGridsAPI SparseGridsC)

if (Tasmanian_ENABLE_BLAS)
    add_test(SparseGridsLAPACK gridtest lapack)
    Tasmanian_set_test_properties(TESTS SparseGridsLAPACK)
endif()

########################################################################
# Install headers and config files
########################################################################
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
        DESTINATION include
        FILES_MATCHING PATTERN "*.hpp"
        PATTERN "*.windows.*" EXCLUDE
        PATTERN "Examples" EXCLUDE
        PATTERN "Benchmarks" EXCLUDE
        PATTERN "tsgHiddenExternals.hpp" EXCLUDE)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/TasmanianSparseGrid.h"
        DESTINATION include
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/Examples/"
        DESTINATION "share/Tasmanian/examples/"
        FILES_MATCHING PATTERN "*.cpp"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/GaussPattersonRule.table"
        DESTINATION "share/Tasmanian/"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

=== Tasgrid/CMakeLists.txt ===
########################################################################
# tasgrid command line tool
########################################################################

########################################################################
# add the tasgrid executable
########################################################################
add_executable(Tasmanian_tasgrid tasgrid_main.cpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestCLICommon.hpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestExternalTests.hpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestExternalTests.cpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestTestHelpers.hpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestTestFunctions.hpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestTestFunctions.cpp
                                 tasgridWrapper.hpp
                                 tasgridWrapper.cpp)

target_link_libraries(Tasmanian_tasgrid Tasmanian_addons)

set_target_properties(Tasmanian_tasgrid PROPERTIES OUTPUT_NAME "tasgrid" CXX_EXTENSIONS OFF)
Tasmanian_rpath_target(TARGET Tasmanian_tasgrid COMPONENTS SparseGrids DREAM)
if (Tasmanian_ENABLE_OPENMP)
    # the OpenMP libraries are carried transitively from sparse grids library
    target_compile_options(Tasmanian_tasgrid PRIVATE ${OpenMP_CXX_FLAGS})
endif()
if (Tasmanian_ENABLE_HIP)
    target_link_libraries(Tasmanian_tasgrid hip::host)
endif()

########################################################################
# Windows specific support (DLL export/import directives and names)
########################################################################
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

    # suppresses warnings regarding pointers to the middle of an array
    target_compile_definitions(Tasmanian_tasgrid PRIVATE -D_SCL_SECURE_NO_WARNINGS)
    # needed to prevent crash on using STL vector iterators
    target_compile_definitions(Tasmanian_tasgrid PUBLIC  -D_HAS_ITERATOR_DEBUGGING=0)

endif()

########################################################################
# Install binaries and shared objects
########################################################################

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/../configured/tasgridLogs.hpp"
        DESTINATION include
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

install(TARGETS Tasmanian_tasgrid
        EXPORT "${Tasmanian_export_name}"
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "lib"
        ARCHIVE DESTINATION "lib")

=== Config/CMakeIncludes/CMakeLists.txt ===
########################################################################
# Install Message
# This is written in this CMakeLists.txt and add subdir is called last
# thus, the message will appear at the very end of the install process
#
# Do not put any other code here, this is for human readability only
########################################################################
set(Tasmanian_post_install "--------------------------------------------------------------------------------\n\n")
set(Tasmanian_post_install "${Tasmanian_post_install}Tasmanian Install Complete: Installed Version ${Tasmanian_VERSION_MAJOR}.${Tasmanian_VERSION_MINOR}${Tasmanian_version_comment}\n\n")
set(Tasmanian_post_install "${Tasmanian_post_install}executable:\n    tasgrid${CMAKE_EXECUTABLE_SUFFIX_CXX}\n")

if (BUILD_SHARED_LIBS)
    set(TSGLTYPE "SHARED")
else()
    set(TSGLTYPE "STATIC")
endif()

set(Tasmanian_post_install "${Tasmanian_post_install}libraries:\n")
foreach(_tsgtarget Tasmanian_libsparsegrid Tasmanian_libdream Tasmanian_libfortran90 Tasmanian_libfortran03)
    if (TARGET ${_tsgtarget})
        get_target_property(_tsgname ${_tsgtarget} OUTPUT_NAME)
        set(Tasmanian_post_install "${Tasmanian_post_install}    ${CMAKE_${TSGLTYPE}_LIBRARY_PREFIX}${_tsgname}${CMAKE_${TSGLTYPE}_LIBRARY_SUFFIX}\n")
    endif()
    unset(_tsgname)
endforeach()
unset(TSGLTYPE)
unset(_tsgtarget)
unset(Tasmanian_fortran_target)

if (Tasmanian_ENABLE_FORTRAN)
    set(Tasmanian_post_install "${Tasmanian_post_install}Fortran module:\n")
    set(Tasmanian_post_install "${Tasmanian_post_install}    tasmanian.mod\n")
    if (Tasmanian_ENABLE_MPI)
        set(Tasmanian_post_install "${Tasmanian_post_install}    tasmanian_mpi.mod\n")
    endif()
    if (Tasmanian_ENABLE_FORTRAN90)
        set(Tasmanian_post_install "${Tasmanian_post_install}    tasmaniansg.mod\n")
    endif()
endif()

set(Tasmanian_post_install "${Tasmanian_post_install}\nsee the examples:\n    ${Tasmanian_final_install_path}/share/Tasmanian/examples/\n\n")

set(Tasmanian_post_install "${Tasmanian_post_install}bash environment setup:\n    source ${Tasmanian_final_install_path}/share/Tasmanian/TasmanianENVsetup.sh\n\n")

set(Tasmanian_post_install "${Tasmanian_post_install}cmake package config:\n    find_package(Tasmanian ${Tasmanian_VERSION_MAJOR}.${Tasmanian_VERSION_MINOR}.${Tasmanian_VERSION_PATCH} PATHS \\\"${Tasmanian_final_install_path}/lib/\\\")\n\n")
set(Tasmanian_post_install "${Tasmanian_post_install}    CMake components:\n")
set(Tasmanian_post_install "${Tasmanian_post_install}             ${Tasmanian_components}\n")
set(Tasmanian_post_install "${Tasmanian_post_install}    CXX targets:\n")
set(Tasmanian_post_install "${Tasmanian_post_install}             Tasmanian::tasgrid      (executable)\n")
set(Tasmanian_post_install "${Tasmanian_post_install}             Tasmanian::Tasmanian    (CXX libraries)\n\n")

if (Tasmanian_ENABLE_FORTRAN)
    set(Tasmanian_post_install "${Tasmanian_post_install}    Fortran targets:\n")
    set(Tasmanian_post_install "${Tasmanian_post_install}             Tasmanian::Fortran      (Fortran libraries)\n\n")
endif()

set(Tasmanian_post_install "${Tasmanian_post_install}    see also:\n        ${Tasmanian_final_install_path}/share/Tasmanian/examples/CMakeLists.txt\n")
set(Tasmanian_post_install "${Tasmanian_post_install}\n")

if (Tasmanian_ENABLE_PYTHON AND ("${Tasmanian_final_install_path}" STREQUAL "${CMAKE_INSTALL_PREFIX}"))
    set(Tasmanian_post_install "${Tasmanian_post_install}python module path and alternatives:\n")
    set(Tasmanian_post_install "${Tasmanian_post_install}    ${Tasmanian_python_install_path}/Tasmanian.py\n    ${CMAKE_INSTALL_PREFIX}/share/Tasmanian/python/Tasmanian.py\n\n")
    set(Tasmanian_post_install "${Tasmanian_post_install}    import sys\n")
    set(Tasmanian_post_install "${Tasmanian_post_install}    sys.path.append(\\\"${CMAKE_INSTALL_PREFIX}/share/Tasmanian/python\\\")\n")
    set(Tasmanian_post_install "${Tasmanian_post_install}    import Tasmanian\n\n")
endif()

if (NOT "${Tasmanian_MATLAB_WORK_FOLDER}" STREQUAL "")
    set(Tasmanian_post_install "${Tasmanian_post_install}matlab scripts location:\n    ${Tasmanian_final_install_path}/share/Tasmanian/matlab/\n\n")
    set(Tasmanian_post_install "${Tasmanian_post_install}    addpath('${Tasmanian_final_install_path}/share/Tasmanian/matlab/')\n")
endif()
set(Tasmanian_post_install "${Tasmanian_post_install}--------------------------------------------------------------------------------\n")

string(REPLACE "\\\"" "\"" _tsg_message "${Tasmanian_post_install}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/Tasmanian.log" "${_tsg_message}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Tasmanian.log"
        DESTINATION "share/Tasmanian/"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)
unset(_tsg_message)

install(CODE "message(\"${Tasmanian_post_install}\")")
install(CODE "message(\"information stored in: ${CMAKE_INSTALL_PREFIX}/share/Tasmanian/Tasmanian.log\n\")")

=== debian/changelog ===
tasmanian (8.1-5) unstable; urgency=medium

  * Rebuild against gfortran 15
  * Drop “Rules-Requires-Root: no”, which is now the default
  * Bump S-V to 4.7.2
  * d/watch: upgrade to format version 5

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 09 Sep 2025 08:03:50 +0200

tasmanian (8.1-4) unstable; urgency=medium

  * Disable autopkgtests that segfault on riscv64
  * Bump S-V to 4.7.1

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 25 Feb 2025 12:22:52 +0100

tasmanian (8.1-3) unstable; urgency=medium

  * Avoid dh_missing error about tasmanian.mod on arch:all builds
    (Closes: #1095755)

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 11 Feb 2025 21:14:34 +0100

tasmanian (8.1-2) unstable; urgency=medium

  * testsuite-i386.patch: new patch, fixes FTBFS on i386

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 11 Feb 2025 17:06:11 +0100

tasmanian (8.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1087848)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 26 Dec 2024 15:06:53 +0100

=== debian/control ===
Source: tasmanian
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-fortran-mod,
               dh-sequence-python3,
               cmake,
               libblas-dev,
               liblapack-dev,
               python3-numpy
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/tasmanian
Vcs-Git: https://salsa.debian.org/science-team/tasmanian.git
Homepage: https://github.com/ORNL/TASMANIAN

Package: tasgrid
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command-line interface to the Tasmanian sparse grids library
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package contains an executable that provides a command-line interface to
 the Tasmanian Sparse Grids module. It provides the ability to create and
 manipulate sparse grids, save and load them into files and optionally
 interface with another program via text files.

Package: libtasmaniansparsegrid8
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian module for sparse grids
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a shared library that implements a variety of sparse
 grids, i.e. a family of algorithms for constructing multidimensional
 quadrature and interpolation rules using multiple tensor products of one
 dimensional rules with varying degree of precision.
 .
 The Tasmanian Sparse Grids Module implements a variety of grids that fall into
 five major categories: global grids, sequence grids, local polynomial grids,
 wavelet grids and fourier grids.

Package: libtasmaniandream8
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian module for drawing samples from an arbitrary probability distribution
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a shared library that implements the DiffeRential
 Evolution Adaptive Metropolis (DREAM), which is a method to draw samples from
 an arbitrary probability distribution defined by an arbitrary non-negative
 function. The DREAM approach is similar to the classical Markov Chain Monte
 Carlo, but it evolves a large number of chains simultaneously which leads to
 better parallelization and (potentially) faster convergence. In addition,
 multiple chains allow for better exploration of the probability domain, which
 is often advantageous when working with multi-modal distributions.
 .
 One of the main applications of DREAM is in the field of Bayesian inference,
 where samples are drawn from a posterior distribution comprised from a
 data-informed likelihood and an arbitrary model. The DREAM module of Tasmanian
 can use Tasmanian Sparse Grids approximation to either the model or the
 likelihood.

Package: libtasmanianfortran8
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian sparse grids wrappers for Fortran 2003
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a SWIG wrapper around the Tasmanian C++ module for
 sparse grids, making it easy to call it from Fortran 2003.

Package: libtasmaniancaddons8
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian add-ons module
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package contains a shared library that provides various additional
 functionalities not included in the core Tasmanian modules.

Package: libtasmanian-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${fortran:Depends},
         libtasmaniansparsegrid8 (= ${binary:Version}),
         libtasmaniandream8 (= ${binary:Version}),
         libtasmanianfortran8 (= ${binary:Version}),
         libtasmaniancaddons8 (= ${binary:Version})
Description: Tasmanian development files
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides all the necessary development files to use the Tasmanian
 modules either from C++, C or Fortran 2003.

Package: octave-tasmanian
Architecture: all
Depends: ${misc:Depends},
         tasgrid
Recommends: octave
Description: Octave interface to the Tasmanian sparse grids module
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a GNU Octave interface to the Tasmanian sparse grids
 module. This interface can also be used from MATLAB.

Package: python3-tasmanian
Architecture: all
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-numpy,
         libtasmanian-dev
Description: Python interface to the Tasmanian sparse grids and DREAM modules
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a Python interface to the Tasmanian sparse grids and
 DREAM modules.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_SKIP_INSTALL_RPATH=TRUE \
		-DTasmanian_ENABLE_BLAS=ON \
		-DBLA_VENDOR=Generic -DBLA_PREFER_PKGCONFIG=TRUE \
		-DTasmanian_ENABLE_OPENMP=ON \
		-DTasmanian_TESTS_OMP_NUM_THREADS=4 \
		-DTasmanian_MATLAB_WORK_FOLDER=/tmp \
		-DTasmanian_ENABLE_FORTRAN=ON \
		-DTasmanian_ENABLE_PYTHON=ON

execute_before_dh_install-arch:
	# Do not leave a .mod in /usr/include (it is arch- and compiler-dependent)
	# dh_fortran_mod will put it in the right place (see libtasmanian-dev.fortran-mod)
	# This rule is made arch-dependent because otherwise arch:all builds fail at dh_missing (see #1095755)
	mv debian/tmp/usr/include/*.mod debian/tmp/

=== debian/tests/control ===
# Example taken from InterfaceCLI.md
Test-Command: tasgrid -mq -dim 4 -depth 2 -type qptotal -1d gauss-legendre -p
Depends: tasgrid

# Segfaults on riscv64 as of version 8.1-3
Tests: interface-cplusplus
Depends: libtasmanian-dev, g++
Restrictions: allow-stderr
Architecture: !riscv64

# NB: There also exists a Fortran 90 interface, but we don’t provide it
Tests: interface-fortran-2003
Depends: libtasmanian-dev, gfortran
Restrictions: allow-stderr

# Segfaults on riscv64 as of version 8.1-3
Test-Command: octave-cli --eval "addpath /usr/share/Tasmanian/matlab; tsgExample"
Depends: octave-tasmanian, octave
Restrictions: allow-stderr
Architecture: !riscv64

# Segfaults on riscv64 as of version 8.1-3
Tests: interface-python
Depends: python3-tasmanian
Restrictions: allow-stderr
Architecture: !riscv64

=== debian/watch ===
Version: 5

Template: Github
Owner: ORNL
Project: TASMANIAN
